<?php
//
//	Module name      :	indent.php
//	Version          :	1.0
//	Started on       :	Maj 3, 2005
//	Completed on     :	Maj 3, 2005
//
//	Module type      :	Library
//	Description      :	Very simple functions to indent an output
//
//	Developed under  :	Php 4.1.2
//	Sw requirements  :	None
//
//	Parameters       :	None
//	Notes - usage    :	Indentation used is composed by 4 spaces; see $I_unit to change them.
//						Unused sections and functions have been removed to speed up execution.
//						An example of usage on Tables can be (functions in [] must be called but
//						must not used for output; syntax is Bnf Extended):
//							table	->  IInd() . "<table>\n" [IMore()] . trlist . ILess() . "</table>\n"
//							trlist	-> (IInd() . "<tr>\n"    [IMore()] . tdlist . ILess() . "</tr>\n")+
//							tdlist	-> (IInd() . "<td>\n"    [IMore()] . elem   . ILess() . "</td>\n")+
//							elem	->  IInd() . "something\n"
//						In the example, the caller must prepare indentation before calling other func.
//						(IMore()) and called funcs must print indentation (IInd()).
//


//--- Public constants -----------------------------------------------------------------------------



define("I_MODULE_NAME", "indent.php 1.0; on Maj 3, 2005 by J.Hubb.");



//--- Public variables -----------------------------------------------------------------------------



$I_unit = "    ";



//--- Private variables ----------------------------------------------------------------------------



$_I_indent = "";

$_I_level = 0;



//--- Public functions code ------------------------------------------------------------------------



function ILess()
// Decrease indentation of one unit, ignoring underflows; returns the new indentation string.
{
	global $_I_level, $_I_indent, $I_unit;

	return ($_I_level == 0 ? "" : ($_I_indent = substr($_I_indent, 0, --$_I_level * strlen($I_unit))));
}



function IMore()
// Increase indentation of one unit; returns the new indentation string.
{
	global $_I_level, $_I_indent, $I_unit;

	$_I_level++;
	return ($_I_indent .= $I_unit);
}



function IReset()
// Resets indentation to zero and returns the new indentation string.
{
	global $_I_level, $_I_indent;

	$_I_level = 0;
	return ($_I_indent = "");
}



function IInd()
// Return current indentation string.
{
	global $_I_indent;

	return $_I_indent;
}



//--- Initialization code --------------------------------------------------------------------------



?>
